<?php
//xbp_form_crud - V bta 0.2 - 14/11/09
//MySQL Form

# ***** BEGIN LICENSE BLOCK *****
# This file is part of XBPlog. - htttp://www.xbplog.com 
# Copyright (c) 2006 LinkMan. All rights reserved.
#
# XBPlog is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#  
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****
require_once 'xbp_form.php';
class xbp_form_crud extends xbp_form
{
	//var $_db = '';
	protected $_elements = array();
	protected $_tables = array();
	protected $_PK = array();
	protected $_FK = array();
	
	/*function __autoload($class_name) {
		require_once $class_name . '.php';
	}*/
	
	//function __construct($db,$table,$init = 1)
	function __construct($db)
	{
		$tab_args = func_get_args();
		array_shift($tab_args);
		
		foreach ($tab_args as $arg)
		{
			$this->_tables[] = $arg; 
			$this->init($arg);
		}
	}

	public function setFK($FKs)
	{
		//'0->id_v_bloget<=>1->id_bloget_v'
		$i = 0; $it = explode('<=>',$FKs);		
		foreach ($it as $cmdFK)
		{
			$FK = explode('->', $cmdFK);
			if (is_numeric($FK[0])) $FK[0] = $this->_tables[$FK[0]];
			
			if ($i == 0) {$key1 = $FK[0]; $key2 = $FK[1];}
			else
				$this->_FK[$key1][$key2] = array($FK[0],$FK[1]);
			$i++;
		}
		/*foreach($FKs as $key => $var)
			$this->_FK[$key] = $var;*/
	}
	
	public function init($table)
	{
		$res = mysql_query('SHOW COLUMNS FROM `'.$table.'`') or die('La table n\'existe pas.');
		//$i = 0;
		while($d = mysql_fetch_array($res)){
			if(strstr($d['Type'],'(')){
			  $type = substr($d['Type'], 0, strpos($d['Type'], "("));
			  $taille = substr($d['Type'], strpos($d['Type'], "(")+1, strlen(strstr($d['Type'], "("))-2);
			 }
			else {
			  $type = $d['Type'];
			  $taille = 0;
			}
			
			$this->addElement($d['Field'], $this->getTypeHTML($type,$taille));
			$lastID = count($this->_elements)-1;
			$this->_elements[$lastID]['Table'] = $table;
			
			switch($type){
				case 'int': case 'mediumint': case 'tinyint':
					$this->_elements[$lastID]['TypeNumeric'] = 1;
				break;
				
				default : $this->_elements[$lastID]['TypeNumeric'] = 0;
			}
			
			/*$lelement['Field'] = $d['Field'];
			$lelement['Type'] = $type;
			list($lelement['TypeHTML'],$lelement['Options']) = $this->getTypeHTML($type,$taille);
			$lelement['TypeB'] = $d['Type'];
			$lelement['Name'] = $d['Field'];
			$lelement['Value'] = '';
			$lelement['Autre'] = '';
				 
		    $lelement['ID'] = $i;
			$lelement['ADDED'] = 'NO';*/
			
			
			if($d['Key'] == 'PRI')$this->_PK[$table] = $d['Field'];
			//$this->_elements[$i] = $lelement;
			//$i++;
		}
	}
	//////////////////////////////////////////////////
	//Return Type and Options with this type.
	//Options end with N or T (N = Numeric / T = Text)
	public function getTypeHTML($type,$size=0){
		switch($type){
			case 'tinyint' AND $size == 1 : return array('type'=>'checkbox','options'=>array('Checked'=>''));
			
			case 'enum' : 
				//print_r($size); exit;
				$size = str_replace('\',\'',',',$size);
				$size = substr($size, 1, -1);
			return array('type'=>'select','options'=>array('Opt'=>explode(',',$size))); 

			
			case 'tinytext' : case 'text' : return $this->getOptionsTextarea(60,5);
			case 'mediumtext' : return $this->getOptionsTextarea(60,7);
			case 'longtext' : return $this->getOptionsTextarea(60,25);
			
			default :
			return array('type'=>'text','options'=>array('Size'=>$size,'Maxlength'=>$size));
		}
	}
	public function getOptionsTextarea($cols,$rows){
		$options['Cols'] = $cols;
		$options['Rows'] = $rows;
		$options['Wrap'] = 'virtual';
				
		return array('type'=>'textarea','options'=>$options);
	}

	
	public function select($where)
	{
		if (count($this->_elements) == 0) return false;
		$whr[$this->_tables[0]] = $where;
		foreach ($this->_tables as $table)
		{
			$res = mysql_query('SELECT * FROM `'.$table.'` WHERE `'.$this->_PK[$table].'` = "'.$whr[$table].'"') or die(mysql_error());
			if (mysql_num_rows($res) == 0) return false;
			
			$d = mysql_fetch_array($res,MYSQL_ASSOC);
			foreach($d as $key => $var)
			{
				$this[$key] = $var;
				if (isset($this->_FK[$table][$key])) $whr[$this->_FK[$table][$key][0]] = $var;
			}
		}
	}
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//Insert dans la BDD
	function insert($var, $more=''){
		$ltables = array_reverse($this->_tables); 
		if(is_array($more))$var = array_merge($var, $more);
		
		foreach ($ltables as $table)
		{
			$columns = ''; $values = '';	
			foreach($var as $key => $value){
			 $lID = $this->getID($key);
			 if ($lID == -1 ||
				 $table != $this->_elements[$lID]['Table'] || 
				 !isset($this->_elements[$lID]['Table'])) 
					continue;
			 
			 $columns .= $key.',';
			 if ($this->_elements[$lID]['TypeNumeric'] != 1)
				$values .= '"'.$value.'",';
			 else {
			  if ($value === '') {
				//Checkbox has no value in $_POST
				if ($this->_elements[$lID]['TypeHTML'] == 'checkbox') 
					$values .= '1,';
				else $values .= '0,';
			  }
			  else $values .= $value.',';
			 }
			}
			
			$columns = substr($columns, 0, -1); $values = substr($values, 0, -1);
			//echo 'INSERT INTO `'.$table.'` ('.$columns.') VALUES('.$values.');<br/>';
			mysql_query('INSERT INTO `'.$table.'` ('.$columns.') VALUES('.$values.');') or die(mysql_error());
			foreach ($this->_FK as $tableFK)
				foreach ($tableFK as $key_fk => $var_fk) 
					if ($var_fk[1] == $this->_PK[$table]) 
						$var[$key_fk] = mysql_insert_id();
		}
		
		return true;
	}
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//Update
	/*function setUpdate($res){
		$d = mysql_fetch_array($res);
		foreach($d as $key => $value){
			if(!is_numeric($key)){
				$lID = $this->getID($key);
				if($this->_elements[$lID]['TypeHTML'] == 'checkbox' && $this->_elements[$lID]['Type'] == 'binary')$this->_elements[$lID]['Options']['Checked'] = 'checked'; 
				else $this->_elements[$lID]['Value'] = $value;
			}
		}
	}*/
	function update($var,$PK,$AND=array()){
		$PKs[$this->_tables[0]] = $PK; 
		foreach ($this->_tables as $table)
		{
			$values = '';
			foreach($var as $key => $value){
			 $lID = $this->getID($key);
			 if ($lID == -1 ||
				 $table != $this->_elements[$lID]['Table'] || 
				 !isset($this->_elements[$lID]['Table'])) 
					continue;
			 
			 if (in_array($key, $this->_PK)) {$PKs[$table] = $value; continue;}
			 
			 $values .= '`'.$key.'`=';
			 //Numeric text !!!!!!!!!!!!!!!!
			 if($this->_elements[$lID]['TypeNumeric'] == 1){
			  if($value === '')$values .= '0, ';
			  else $values .= $value.', ';
			 }
			 else $values .= '"'.(addslashes($value)).'", ';
			}
			
			$values = substr($values, 0, -2);
			/*foreach ($this->_FK as $tableFK)
				foreach ($tableFK as $key_fk => $var_fk)
					if ($var_fk[1] == $this->_PK[$table]) 
						$PKs[$table] = $this->_elements[8]['Value'];*/
			if (!is_numeric($PKs[$table])) $PKs[$table] = '"'.$PKs[$table].'"';
			if (!isset($AND[$table])) $AND[$table] = '';

						
			//echo $values.'<br/>';
			//echo 'UPDATE `'.$table.'` SET '.$values.' WHERE `'.$this->_PK[$table].'`='.$PKs[$table].' '.$AND[$table].'<br/>';
			mysql_query('UPDATE `'.$table.'` SET '.$values.' WHERE `'.$this->_PK[$table].'`='.$PKs[$table].' '.$AND[$table].';') or die(mysql_error());

		}
	}


	function getFromFK($offset,$path,$moreOpt=array())
	{
		if (!is_numeric($offset)) $offset = $this->getID($offset);
		if ($offset == -1) return false;
		
		$path = explode('|',$path);
		$keydata = explode('->', $path[count($path)-1]);
		$columns = explode('--', $keydata[1]);
		$select = '';
		foreach($columns as $key => $var)
			$select .= '`'.$keydata[0].'`.`'.$var.'`, ';
		$res = mysql_query('SELECT '.(substr($select, 0, -2)).' FROM '.$keydata[0]) or die('La table n\'existe pas.');
		
		
		// if (isset($moreOpt['start'])) {
			// if (!is_array($moreOpt['start'][0]))
				// $opt[] = $moreOpt['start'];
			// else {	
				// foreach($moreOpt['start'] as $key => $var)
					// $opt[$key] = $var;
			// }
		// }
		if (isset($moreOpt['start']))
		{
			foreach($moreOpt['start'] as $key => $var)
				$opt[$key] = $var; 
		}
		while($d = mysql_fetch_array($res))
			$opt[$d[$columns[1]]] = $d[$columns[0]];
			
		$this->_elements[$offset]['TypeHTML'] = 'select';
		$this->_elements[$offset]['Options']['Opt'] = $opt;	
		
		//Peut tre  effacer par la suite
		if (!isset($this->_elements[$offset]['Options']['J_S']))
			$this->_elements[$offset]['Options']['J_S'] = '';		
		
		return true;
	}
}
?>